service: eventick-users
useDotenv: true
plugins:
  - serverless-plugin-typescript
  - serverless-prune-plugin
  - serverless-offline
custom:
  prune:
    automatic: true
    number: 3
provider:
  name: aws
  runtime: nodejs16.x
  region: eu-west-3
  memorySize: 400
  timeout: 120
  iam:
    role:
      statements:
        - Effect: Allow
          Action:
            - logs:CreateLogsGroup
            - logs:CreateLogsStream
            - logs:PutLogsEvents
          Resource: '*'
  vpc:
    securityGroupIds:
      - sg-0f08608bd3a205c6f
    subnetIds:
      - subnet-0896cdd29515a699f
      - subnet-05f8752251b4b5e47
      - subnet-07131f18a02ba82c7
functions:
  get-me:
    handler: src/functions/get-me.handler
    events:
      - http:
          path: /me
          method: GET
          cors:
            origins: '*'
            headers:
              - Content-type
              - Authorization
              - x-api-key
              - x-app-version
              - x-brand
              - x-device
              - x-locale
              - x-origin
              - x-os-version
            allowCredentials: true
  get-users:
    handler: src/functions/get-users.handler
    events:
      - http:
          path: /
          method: GET
          cors:
            origins: '*'
            headers:
              - Content-type
              - Authorization
              - x-api-key
              - x-app-version
              - x-brand
              - x-device
              - x-locale
              - x-origin
              - x-os-version
            allowCredentials: true
  get-user-details:
    handler: src/functions/get-user-detail.handler
    events:
      - http:
          path: /{user_id}
          method: GET
          cors:
            origins: '*'
            headers:
              - Content-type
              - Authorization
              - x-api-key
              - x-app-version
              - x-brand
              - x-device
              - x-locale
              - x-origin
              - x-os-version
            allowCredentials: true
  delete-user:
    handler: src/functions/delete-user.handler
    events:
      - http:
          path: /{user_id}
          method: DELETE
          cors:
            origins: '*'
            headers:
              - Content-type
              - Authorization
              - x-api-key
              - x-app-version
              - x-brand
              - x-device
              - x-locale
              - x-origin
              - x-os-version
            allowCredentials: true
  update-user:
    handler: src/functions/update-user.handler
    events:
      - http:
          path: /
          method: POST
          cors:
            origins: '*'
            headers:
              - Content-type
              - Authorization
              - x-api-key
              - x-app-version
              - x-brand
              - x-device
              - x-locale
              - x-origin
              - x-os-version
            allowCredentials: true
  put-user:
    handler: src/functions/put-user.handler
    events:
      - http:
          path: /
          method: PUT
          cors:
            origins: '*'
            headers:
              - Content-type
              - Authorization
              - x-api-key
              - x-app-version
              - x-brand
              - x-device
              - x-locale
              - x-origin
              - x-os-version
            allowCredentials: true
resources:
  Resources:
    GatewayResponseDefault4XX:
      Type: AWS::ApiGateway::GatewayResponse
      Properties:
        ResponseParameters:
          gatewayresponse.header.Access-Control-Allow-Origin: "'*'"
          gatewayresponse.header.Access-Control-Allow-Headers: "'*'"
        ResponseType: DEFAULT_4XX
        RestApiId:
          Ref: ApiGatewayRestApi
    GatewayResponseDefault5XX:
      Type: AWS::ApiGateway::GatewayResponse
      Properties:
        ResponseParameters:
          gatewayresponse.header.Access-Control-Allow-Origin: "'*'"
          gatewayresponse.header.Access-Control-Allow-Headers: "'*'"
        ResponseType: DEFAULT_5XX
        RestApiId:
          Ref: ApiGatewayRestApi
